#if !defined(__TABWND_H__)
#define __TABWND_H__

// TabWnd.h : Header File
//

///////////////////////////////////////////////////////////////
// CTabbedFrameWnd frame

#include <afxtempl.h>

class AFX_EXT_CLASS CTabbedFrameWnd : public CFrameWnd
{
    DECLARE_DYNCREATE(CTabbedFrameWnd)
protected:
    CTabbedFrameWnd();           

public:
    virtual BOOL AddView(CCreateContext* pContext);
    using CFrameWnd::SetActiveView;
    virtual VOID SetActiveView(int nNewTab);
    virtual BOOL OnCloseCurrentDoc(void);
    virtual BOOL OnCloseDoc(int nTab);

// overrides
public:
    virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
    virtual BOOL LoadFrame(UINT nIDResource, 
        DWORD dwDefaultStyle = WS_OVERLAPPEDWINDOW|FWS_ADDTOTITLE,
        CWnd* pParentWnd = NULL, CCreateContext* pContext = NULL);
    virtual VOID OnUpdateFrameTitle(BOOL bAddToTitle);
    protected:
    virtual BOOL OnCreateClient(LPCREATESTRUCT lpcs, 
        CCreateContext* pContext);
    virtual void RecalcLayout(BOOL bNotify = TRUE);

// implementation
protected:
    virtual ~CTabbedFrameWnd();

    CTabCtrl            m_TabCtrl;
    CToolTipCtrl*       m_pToolTip;
    CView*              m_pActiveView;
    int                 m_nActiveTab;
    CArray<CWnd*, CWnd*>m_arrViews;

    afx_msg VOID OnTabSelChange(NMHDR* pnmhdr, LRESULT* pResult);
    afx_msg VOID OnClose();
    
    static CString GetShortName(const CString& strName, 
                                UINT nTargetLen);

    static CString ShortenName(const CString& strFullName, 
                               UINT nTarget);
    

    DECLARE_MESSAGE_MAP()
};

UINT GetFileName(LPCTSTR lpszPathName, 
                 LPTSTR lpszTitle, UINT nMax);

#endif 
