// childp.c

#include <windows.h>
#include "childp.h"

int CALLBACK ChildDlgProc(HWND, UINT, WPARAM, LPARAM);
DWORD WINAPI WorkerThread(LPVOID); 

HANDLE hInst, hThread;
DWORD minWSS, maxWSS, min1, max1;

//-----------------------------------------------------------------
int APIENTRY WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                     LPSTR lpCmdLine, int nCmdShow)
{
    hInst = hInstance;
    GetProcessWorkingSetSize(GetCurrentProcess(), &minWSS, &maxWSS);
    hThread = CreateThread(NULL, 0, WorkerThread, 0, 
                           CREATE_SUSPENDED, NULL);
    DialogBox(hInst,MAKEINTRESOURCE(DLG_CHILD),NULL,ChildDlgProc);
}

//-----------------------------------------------------------------
int CALLBACK ChildDlgProc(HWND hDlg, UINT Message, WPARAM wParam,
                          LPARAM lParam)
{
    char sz[MAX_PATH];
    static LPBYTE p = NULL, pBuffer = NULL;
    static DWORD dwSize = 0x4000000; // 64MB
    HANDLE hProcess = GetCurrentProcess();

    switch (Message) {
        case WM_COMMAND:
            switch (LOWORD(wParam)) {
                case IDOK:
                    EndDialog(hDlg, TRUE);
                    return TRUE;

                case ID_BEEPER_ON:                   
                    if (!SystemParametersInfo(SPI_SETBEEP, TRUE,
                                              NULL, FALSE)) {
                        wsprintf(sz, "Error (%x)!", GetLastError());
                        MessageBox(hDlg, sz, "Childp", MB_OK);
                    }
                    break;

                case ID_BEEPER_OFF:                   
                    if (!SystemParametersInfo(SPI_SETBEEP, FALSE,
                                              NULL, FALSE)) {
                        wsprintf(sz, "Error (%x)!", GetLastError());
                        MessageBox(hDlg, sz, "Childp", MB_OK);
                    }
                    break;

                case ID_INCREASE_MAX_WSS:
                    maxWSS *= 2;
                    SetProcessWorkingSetSize(hProcess,minWSS,maxWSS);
                    GetProcessWorkingSetSize(hProcess,&min1, &max1);
                    if (max1 < maxWSS) {
                        MessageBox(hDlg, "Error", "Childp", MB_OK);
                    }
                    break;

                case ID_SUSPEND_THREAD:
                    SuspendThread(hThread);
                    break;

                case ID_RESUME_THREAD:
                    ResumeThread(hThread);
                    break;

                case ID_ALLOC_BUFFER:
                    if (pBuffer) {
                        dwSize *= 2;
                        p = realloc(pBuffer, dwSize);
                        if (p) {
                            pBuffer = p;
                        } else {
                            wsprintf(sz,"Error (%x)",GetLastError());
                            MessageBox(hDlg, sz, "Childp", MB_OK);
                        }
                    } else {
                        p = malloc(dwSize);
                        if (p) {
                            pBuffer = p;
                        } else {
                            wsprintf(sz,"Error (%x)",GetLastError());
                            MessageBox(hDlg, sz, "Childp", MB_OK);
                        }
                    }
                    break;

                case ID_FREE_BUFFER:
                    if (pBuffer) {
                        free(pBuffer);
                        pBuffer = NULL;
                    }
                    break;
            }

        default:
            return FALSE;
    }
}

//-----------------------------------------------------------------
DWORD WINAPI WorkerThread(LPVOID lpParameter) 
{
    int i=0;
    while (TRUE) {
        i++; // spin
    }
}
