VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "clsLoanPayment"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private m_dInterest As Double  '// interest rate as percentage
Private m_lTerm As Long        '// term in months
Private m_cAmount As Currency  '// amount of loan

Private Function calcPayment(dInterest As Double, _
                             lTerm As Long, _
                             cAmount As Currency) As Currency
        
'/* zero values would generate an 'Illegal Function' error 5 */
    If dInterest <> 0 And lTerm <> 0 And cAmount <> 0 Then
        calcPayment = _
            CCur(Pmt(dInterest, CDbl(lTerm), CDbl(cAmount)))
    End If
    
End Function

Public Function calculatePayment3( _
                    Optional dInterest As Double = 0, _
                    Optional lTerm As Long = 0, _
                    Optional cAmount As Currency = 0) As Currency
                                  
'/* supply missing parameters from properties */
    If dInterest = 0 Then
        dInterest = m_dInterest
    End If
    
    If lTerm = 0 Then
        lTerm = m_lTerm
    End If
    
    If cAmount = 0 Then
        cAmount = m_cAmount
    End If
    
'/* return */
    calculatePayment3 = calcPayment(dInterest, lTerm, cAmount)
    
End Function

Public Function calculatePayment1() As Currency
                                  
'/* return */
    calculatePayment1 = _
        calcPayment(m_dInterest, m_lTerm, m_cAmount)
    
End Function

Public Function calculatePayment2(dInterest As Double, _
                                  lTerm As Long, _
                                  cAmount As Currency) As Currency
                                  
'/* return */
    calculatePayment2 = calcPayment(dInterest, lTerm, cAmount)
    
End Function



Public Property Get Interest() As Double
Attribute Interest.VB_Description = "Interest as percentage (ie. .095 for 9.5%)."
    
    Interest = m_dInterest
    
End Property

Public Property Let Interest(ByVal dInterest As Double)

    m_dInterest = dInterest
    
End Property

Public Property Get Term() As Long
Attribute Term.VB_Description = "Term of loan in months."

    Term = m_lTerm
    
End Property

Public Property Let Term(ByVal lTerm As Long)

    m_lTerm = lTerm
    
End Property

Public Property Get Amount() As Currency
Attribute Amount.VB_Description = "Amount of loan."

    Amount = m_cAmount
    
End Property

Public Property Let Amount(ByVal cAmount As Currency)

    m_cAmount = cAmount
    
End Property
