Attribute VB_Name = "basTypeMisc"
Option Explicit
Public Function getInvokeKindsName(ik As InvokeKinds) As String

    Dim sName As String
    
    Select Case ik
        Case INVOKE_EVENTFUNC
            sName = "Event Function"
        Case INVOKE_FUNC
            sName = "Function"
        Case INVOKE_PROPERTYGET
            sName = "Property Get"
        Case INVOKE_PROPERTYPUT
            sName = "Property Put"
        Case INVOKE_PROPERTYPUTREF
            sName = "Property Put by Reference"
        Case INVOKE_UNKNOWN
            sName = "Unknown"
        Case Else
            sName = "Invalid InvokeKind"
    End Select
    
'/* return */
    getInvokeKindsName = sName
    
End Function
    
Public Function ignoreName(sName As String) As Boolean
    
    Dim bIgnore As Boolean
    
'/* ignore standard COM methods */
    If sName = "Invoke" Or sName = "GetIDsOfNames" Or _
        sName = "GetTypeInfo" Or sName = "GetTypeInfoCount" Or _
        sName = "Release" Or sName = "AddRef" Or _
        sName = "QueryInterface" Then
        bIgnore = True
    Else
        bIgnore = False
    End If
    
'/* return */
    ignoreName = bIgnore
    
End Function
Public Function getVTTypeName(vtType As VarFlags) As String
    
    Dim lType As Long
    
    Dim sType As String
    Dim sVBType As String
    Dim sArray As String
    Dim sByRef As String
    Dim sRet As String
    
    lType = vtType
    
'/* set array string if array bit set */
    sArray = ""
    If (lType Or VT_ARRAY) = lType Then
        lType = lType - VT_ARRAY
        sArray = "(VT_ARRAY)"
    End If
    
'/* set reference string if byref bit set */
    sByRef = ""
    If (lType Or VT_BYREF) = lType Then
        lType = lType - VT_BYREF
        sByRef = "(VT_BYREF)"
    End If
    
'/* set type lib variant type string description */
'/* not all types defined in VB (so use variant name) */
    Select Case lType
        'VT_ARRAY  // see above
        Case VT_BLOB
            sType = "BLOB"
        Case VT_BLOB_OBJECT
            sType = "BLOB OBJECT"
        Case VT_BOOL
            sType = "BOOL"
            sVBType = "Boolean"
        Case VT_BSTR
            sType = "BSTR"
            sVBType = "String"
        'VT_BYREF  // see above
        Case VT_CARRAY
            sType = "VT_CARRAY"
        Case VT_CF
            sType = "VT_CF"
        Case VT_CLSID
            sType = "VT_CLSID"
        Case VT_CY
            sType = "CY"
            sVBType = "Currency"
        Case VT_DATE
            sType = "VT_DATE"
            sVBType = "Date"
        Case VT_DECIMAL
            sType = "VT_DECIMAL"
        Case VT_DISPATCH
            sType = "DISPATCH"
            sVBType = "Object"
        Case VT_EMPTY
            sType = "EMPTY"
        Case VT_ERROR
            sType = "ERROR"
        Case VT_FILETIME
            sType = "FILETIME"
        Case VT_HRESULT
            sType = "HRESULT"
        Case VT_I1
            sType = "VT_I1"
        Case VT_I2
            sType = "VT_I2"
            sVBType = "Integer"
        Case VT_I4
            sType = "VT_I4"
            sVBType = "Long"
        Case VT_I8
            sType = "VT_I8"
        Case VT_INT
            sType = "VT_INT"
        Case VT_LPSTR
            sType = "VT_LPSTR"
        Case VT_LPWSTR
            sType = "VT_LPWSTR"
        Case VT_NULL
            sType = "VT_NULL"
        Case VT_PTR
            sType = "VT_PTR"
        Case VT_R4
            sType = "VT_R4"
        Case VT_R8
            sType = "VT_R8"
            sVBType = "Double"
        Case VT_RESERVED
            sType = "VT_RESERVED"
        Case VT_SAFEARRAY
            sType = "VT_SAFEARRAY"
            sVBType = "Variant Array"
        Case VT_STORAGE
            sType = "VT_STORAGE"
        Case VT_STORED_OBJECT
            sType = "VT_STORED_OBJECT"
        Case VT_STREAM
            sType = "VT_STREAM"
        Case VT_STREAMED_OBJECT
            sType = "VT_STREAMED_OBJECT"
        Case VT_UI1
            sType = "VT_UI1"
        Case VT_UI2
            sType = "VT_UI2"
        Case VT_UI4
            sType = "VT_UI4"
        Case VT_UI8
            sType = "VT_UI8"
        Case VT_UINT
            sType = "VT_UINT"
        Case VT_UNKNOWN
            sType = "VT_UNKNOW"
        Case VT_USERDEFINED
            sType = "VT_USERDEFINED"
        Case VT_VARIANT
            sType = "VT_VARIANT"
            sVBType = "Variant"
        Case VT_VECTOR
            sType = "VT_VECTOR"
        Case VT_VOID
            sType = "VT_VOID"
        Case Else
            sType = "undefined vttype=" & CStr(vtType)
    End Select
    
'/* build type name */
    sRet = sType
    If sVBType <> "" Then
        sRet = sVBType
    End If
    If sArray <> "" Then
        sRet = sRet & " " & sArray
    End If
    If sByRef <> "" Then
        sRet = sRet & " " & sByRef
    End If
    
'/* return */
    getVTTypeName = sRet
    
End Function
    
    
    
    
Public Function setType(sValue As String, iParmType As Integer) _
                        As Variant
    
    Dim vParm As Variant
    
'/* set and return variant with specified parameter type */
'/* note: only a subset of type lib types defined */
    Select Case iParmType
            
        Case VT_BOOL
            vParm = CBool(sValue)
            
        Case VT_BSTR
            vParm = sValue  '// string
            
        Case VT_DATE
            vParm = CDate(sValue)
            
        Case VT_CY
            vParm = CCur(sValue)
            
        Case VT_I4
            vParm = CLng(sValue)
            
        Case VT_R8
            vParm = CDbl(sValue)
            
        Case VT_VARIANT
            vParm = CVar(sValue)
            
        Case VT_EMPTY
            vParm = Null
            
        Case Else  '// assume string
            vParm = sValue
            
    End Select
    
'/* return */
    setType = vParm
    
End Function
    
    
